﻿Imports Infragistics.Win.UltraWinTabControl
Imports Infragistics.Win

Public Class ArchitectWindow

    Private Sub ArchitectWindow_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        tvwPartFamilyTree.Nodes.Clear()
        PopulateApplications()
        PopulatePartFamilyList()
    End Sub

    Public Sub PopulateApplications()
        Dim applications As New ArrayList
        Dim ds As DataSet = Nothing

        Try
            System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.WaitCursor

            cboApplications.DataSource = Nothing

            'm_applications = g_RsUser.GetApplicationsForUser(g_RsUser.UserName, g_RsUser.IsInRole("Admin"))
            'If m_applications.Count > 0 Then
            '    Dim iEnum As IEnumerator = m_applications.GetEnumerator
            '    While iEnum.MoveNext
            '        Dim application As RuleStream.ApplicationInfo.Application = CType(CType(iEnum.Current, DictionaryEntry).Value, RuleStream.ApplicationInfo.Application)
            '        applications.Add(application)
            '    End While

            '    applications.Sort(New mySortClass)
            applications.Add("Dummy Application1")
            applications.Add("Dummy Application2")
            cboApplications.DataSource = applications
            cboApplications.SelectedIndex = 0
            'End If
        Catch ex As Exception
            Dim msg As String = String.Format("PartFamilyList.PopulateApplicationsList(): The following error occurred while loading the Applications List:{0}{0}{1}", ControlChars.NewLine, ex.Message)
            'logger.Error(msg)
            MessageBox.Show(msg, "Populate Applications List", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.Default
        End Try
    End Sub


    Public Sub PopulatePartFamilyList()
        Dim newNode As TreeNode = Nothing
        tvwPartFamily.Visible = False
        tvwPartFamilyTree.Visible = True
        tvwPartFamilyTree.ShowLines = True
        tvwPartFamilyTree.ShowPlusMinus = True
        tvwPartFamilyTree.ShowRootLines = True
        newNode = tvwPartFamilyTree.Nodes.Add("Part_Family_ID1", "Part_Family_Name1")
        newNode = tvwPartFamilyTree.Nodes.Add("Part_Family_ID2", "Part_Family_Name2")
        newNode = tvwPartFamilyTree.Nodes.Add("Part_Family_ID3", "Part_Family_Name3")
        newNode = tvwPartFamilyTree.Nodes.Add("Part_Family_ID4", "Part_Family_Name4")
        'newSpec = CType(New RuleStream.Architect.PartFamilySpecification(CType(dr.Item("Part_Family_ID"), Int32), dr.Item("Name").ToString, True), RuleStream.Architect.IRsSpecification)
        'newNode.ImageKey = GetPartImageName(newSpec)
        'newNode.ImageKey = PartFamilyImageList.Images(2)
        'newNode.SelectedImageKey = newNode.ImageKey
        'newNode.Tag = newSpec

        'newNode.ImageKey = GetPartImageName(newSpec)
        'newNode.SelectedImageKey = newNode.ImageKey
    End Sub

    Private Sub tvwPartFamilyTree_NodeMouseClick(sender As Object, e As System.Windows.Forms.TreeNodeMouseClickEventArgs) Handles tvwPartFamilyTree.NodeMouseClick
        Dim treeViewControl As TreeView = CType(sender, TreeView)
        Dim blnReadOnly As Boolean = False
        If e.Button = Windows.Forms.MouseButtons.Right Then
            treeViewControl.SelectedNode = e.Node

        End If
        Dim contextMenu As ContextMenuStrip = New ContextMenuStrip
        Dim contextItem As ToolStripItem = Nothing

        contextItem = contextMenu.Items.Add("Create new Tab for dummy PartFamily", ContextMenuImageList.Images.Item("PartFamilySpec"))
        contextItem.Enabled = True
        AddHandler contextItem.Click, AddressOf createNewTabControl
        contextMenu.Show(treeViewControl.PointToScreen(e.Location))
    End Sub


    Private Sub createNewTabControl(sender As Object, e As EventArgs)
        Dim strPfName As String = tvwPartFamilyTree.SelectedNode.Text
        Dim tab As UltraTab = New UltraTab
        Dim tabPage As UltraTabPageControl = New UltraTabPageControl
        Dim View As PartFamilyView = New PartFamilyView()
        Dim ctl As Control = CType(View, Control)
        ctl.Dock = DockStyle.Fill
        tab.Key = strPfName
        tab.Text = strPfName
        tab.TabPage = tabPage
        tab.AllowMoving = DefaultableBoolean.False
        tab.AllowClosing = DefaultableBoolean.True
        tab.Visible = True
        tabPage.AutoScroll = True
        tabPage.AutoScrollMinSize = getMinSize(ctl)
        tabPage.Controls.Add(ctl)

        UltraTabControl1.Tabs.Add(tab)
        Me.UltraTabControl1.Controls.Add(tabPage)
        tab.TabPage.Refresh()
        Me.UltraTabControl1.Dock = DockStyle.Fill
        tab.Selected = True

    End Sub
    Private Function getMinSize(ByVal ctl As Control) As Size

        Dim w As Int32 = ctl.MinimumSize.Width
        Dim h As Int32 = ctl.MinimumSize.Height

        If w < 620 Then w = 620
        If h < 620 Then h = 620

        Return New Size(w, h)

    End Function




End Class
